#pragma semicolon 1

#include <sourcemod>
#include <sdkhooks>
#include <sdktools>
#include <lvl_ranks>
#include <vip_core>
#include <clientprefs>

#pragma newdecls required

Menu g_hMenu;
Handle g_hCookie;
StringMap g_hRanks;
int	m_iCompetitiveRanking;
char g_sRanks[MAXPLAYERS + 1][64];

public Plugin myinfo =
{
	name = "[VIP] FakeRank",
	author = "TiNiK",
	version = "1.0.2"
};

public void OnPluginEnd() 
{
	VIP_UnregisterMe();
}

public void OnPluginStart()
{
	g_hRanks = new StringMap();
	m_iCompetitiveRanking = FindSendPropInfo("CCSPlayerResource", "m_iCompetitiveRanking");
	
	g_hCookie = RegClientCookie("vip_lr_fakerank", "", CookieAccess_Private);
	
	if(VIP_IsVIPLoaded())
		VIP_OnVIPLoaded();
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature("fakerank", BOOL, HIDE);
	VIP_RegisterFeature("lr_select_fakerank", _, SELECTABLE, OnSelectItem, _, OnDrawItem);
}

public void OnMapStart()
{
	int value;
	ArrayList hArray;
	char sName[32], sBuff[256];
	if(g_hMenu) delete g_hMenu;
	KeyValues hKV = OpenConfig();
	
	g_hMenu = CreateMenu(MainMenuCallback, MenuAction_DisplayItem);
	SetMenuTitle(g_hMenu, "Выбор набора рангов\n ");
	SetMenuExitBackButton(g_hMenu, true);
	
	do
	{
		KvGetSectionName(hKV, sName, sizeof(sName));

		if(GetTrieValue(g_hRanks, sName, hArray)) ClearArray(hArray);
		else
		{
			hArray = new ArrayList();
			SetTrieValue(g_hRanks, sName, hArray);
		}

		if(!KvJumpToKey(hKV, "ranks") || !KvGotoFirstSubKey(hKV, false))
			SetFailState("Ranks for \"%s\" were not found in configuration file.", sName);
		
		do
		{
			value = KvGetNum(hKV, NULL_STRING);
			PushArrayCell(hArray, value);
			FormatEx(sBuff, sizeof(sBuff), "materials/panorama/images/icons/skillgroups/skillgroup%i.svg", value);
			AddFileToDownloadsTable(sBuff);
		} while (KvGotoNextKey(hKV, false));
		
		KvRewind(hKV);
		KvJumpToKey(hKV, sName);
		
		KvGetString(hKV, "name", sBuff, sizeof(sBuff));
		AddMenuItem(g_hMenu, sName, sBuff);
	} while (KvGotoNextKey(hKV)); 
	
	CloseHandle(hKV);
	
	SDKHook(GetPlayerResourceEntity(), SDKHook_ThinkPost, OnThinkPost);
}

public bool OnSelectItem(int client, const char[] sFeature)
{
	DisplayMenu(g_hMenu, client, MENU_TIME_FOREVER);
	
	return false;
}

public int OnDrawItem(int client, const char[] sFeature, int style)
{
	switch(VIP_GetClientFeatureStatus(client, "fakerank"))
	{
		case ENABLED: return ITEMDRAW_DEFAULT;
		case DISABLED: return ITEMDRAW_DISABLED;
		case NO_ACCESS: return ITEMDRAW_RAWLINE;
	}

	return style;
}

public int MainMenuCallback(Menu hMenu, MenuAction action, int client, int param2)
{ 
	switch (action) 
	{  
		case MenuAction_Select: 
		{ 
			char sItem[32];
			GetMenuItem(hMenu, param2, sItem, sizeof(sItem)); 
			if(strcmp(sItem, g_sRanks[client]))
			{
				strcopy(g_sRanks[client], sizeof(g_sRanks[]), sItem);
				SetClientCookie(client, g_hCookie, g_sRanks[client]);
			}
			
			DisplayMenu(g_hMenu, client, MENU_TIME_FOREVER);
		}
		case MenuAction_DisplayItem: 
		{ 
			char sItem[32], sDisplay[128];
			GetMenuItem(hMenu, param2, sItem, sizeof(sItem), _, sDisplay, sizeof(sDisplay)); 
			
			if(!strcmp(g_sRanks[client], sItem))
			{
				Format(sDisplay, sizeof(sDisplay), "> %s", sDisplay);
				return RedrawMenuItem(sDisplay);
			}
		}
		case MenuAction_Cancel:
		{
			if (param2 == MenuCancel_ExitBack)
			{
				VIP_SendClientVIPMenu(client);
			}
		}
	}
	
	return 0;
}

public void OnClientCookiesCached(int client)
{
	int shit;
	GetClientCookie(client, g_hCookie, g_sRanks[client], sizeof(g_sRanks[]));
	if(!g_sRanks[client][0] || !GetTrieValue(g_hRanks, g_sRanks[client], shit))
		strcopy(g_sRanks[client], sizeof(g_sRanks[]), "default");
}

void OnThinkPost(int iEnt)
{
	int rank;
	ArrayList hArray;

	for (int i = MaxClients + 1; --i;)
	{
		if(IsClientInGame(i) && !IsFakeClient(i) && LR_GetClientStatus(i) && (rank = LR_GetClientInfo(i, ST_RANK)) > 0)
		{
			if(GetTrieValue(g_hRanks, VIP_GetClientFeatureBool(i, "fakerank") ? g_sRanks[i] : "default", hArray))
				SetEntData(iEnt, m_iCompetitiveRanking + i*4, GetArrayCell(hArray, rank - 1));
		}
	}
}

public void OnPlayerRunCmdPost(int client, int iButtons)
{
	static int iOldButtons[MAXPLAYERS+1];

	if(iButtons & IN_SCORE && !(iOldButtons[client] & IN_SCORE))
	{
		StartMessageOne("ServerRankRevealAll", client, USERMSG_BLOCKHOOKS);
		EndMessage();
	}

	iOldButtons[client] = iButtons;
}

KeyValues OpenConfig()
{
	char sBuff[256];
	BuildPath(Path_SM, sBuff, sizeof(sBuff), "data/vip/modules/lr_fakerank.ini"); 
	
	KeyValues hKV = CreateKeyValues("Settings");
	if (!hKV)
 		SetFailState("Failed to allocate memory to read config.");

	if(!FileToKeyValues(hKV, sBuff))
		SetFailState("Configuration file was not found.");
	
	if(!KvGotoFirstSubKey(hKV))
		SetFailState("Ranks were not found in configuration file.");
		
	return hKV;
}